#!/usr/bin/awk -f
#
# $Id: genhtml.awk,v 1.20 2001/09/14 15:11:56 wcampbel Exp $
#
# Generate the html.c file, which provides the code for the HTML dump

BEGIN {
  print "/* html.c - generated source file to perform HTML dumps of"
  print "**          the Stats data."
  print "** DO NOT EDIT!!!"
  print "*/"
  print " "
  print "#include \"stats.h\""
  print "#include \"struct.h\""
  print "#include \"proto.h\""
  print "#include \"patchlevel.h\""
  print " "
  print "void DumpHTML()"
  print "{"
  print "  FILE *fp = fopen(settings.html, \"w\");"
  print "  time_t now = time(NULL);"
  print "  Server *s;"
  print "  User *u;"
  print "  int i;"
  print "  TLD *t;"
  print " "
  print "  int showadmin = 0;"
  print "  int hideuplink = 0;"
  print "#ifdef TRACK_VERSION"
  print "  int hideversion = 0;"
  print "#endif"
  print " "
  print "  if (!fp)"
  print "  {"
  print "    log(\"Unable to open HTML Dump file %s for writing.\","
  print "         settings.html);"
  print "    return;"
  print "  }"
  print " "
  print "  log(\"HTML Dump file %s opened\", settings.html);"
  print " "
  print " /* write out the HTML heading lines */"
  print " "
}

{
  if ($1 == "!NETWORK_DATA!") {
    print " "
    print "#ifdef STATSERV"
    print "  fprintf(fp, \"<B>My Name:</B> %s!%s@%s on %s<BR>\\n\", StatServ.nick, StatServ.user, StatServ.host, settings.name);"
    print "#endif"
    print "  fprintf(fp, \"<B>My Uplink:</B> %s<BR>\\n\", (me.s) ? me.s->name : \"NONE\");"
    print "  fprintf(fp, \"<B>My Admin:</B> %s<BR>\\n\", settings.admin_name);"
    print "  fprintf(fp, \"<B>Current User Count:</B> %ld<BR>\\n\", netinfo.users);"
    print "  fprintf(fp, \"<B>Max Users:</B> %ld at %s<BR>\\n\", netinfo.maxusers, sftime(netinfo.t_maxusers));"
    print "  /* hybrid doesn't propegate AWAY, so don't print it out */"
    print "#if defined(IRCD_2_10) || defined(IRCD_HYB7) || defined(IRCD_OPN)"
    print "  fprintf(fp, \"<B>Current AWAY User Count:</B> %d<BR>\\n\", netinfo.away);"
    print "#endif"
    print "  fprintf(fp, \"<B>Current Oper Count:</B> %d<BR>\\n\", netinfo.opers);"
    print "  fprintf(fp, \"<B>Max Opers:</B> %d at %s<BR>\\n\", netinfo.maxopers, sftime(netinfo.t_maxopers));"
    print "  fprintf(fp, \"<B>Current Server Count:</B> %d<BR>\\n\", netinfo.servers);"
    print "  fprintf(fp, \"<B>Max Servers:</B> %d at %s<BR>\\n\", netinfo.maxservers, sftime(netinfo.t_maxservers));"
    print "  fprintf(fp, \"<B>Statistics Last Updated:</B> %s<BR>\\n\", sftime(now));"
    print "  fprintf(fp, \"<B>Current Uptime:</B> %s<BR>\\n\", timediff(time(NULL) - me.t_start));"
    print " "
  } else if ($1 == "!STATS_VERSION!") {
    print " "
    print "  fprintf(fp, \"<B>Stats Version:</B> %s(%s) %s<BR>\\n\", PATCHLEVEL, SERIALNUM, VersionFlags());"
    print " "
  } else if ($1 == "!SERVER_LIST!") {
    print " "
    print "  for (i=0; i < S_TABLE_SIZE; i++)"
    print "    for (s = serverlist[i]; s; s = s->next)"
    print "      fprintf(fp, \"<A HREF=\\\"#%s\\\">%s</A><BR>\\n\", s->name, s->name);"
    print " "
  } else if ($1 == "!MAP_LIST!") {
    print " "
    print "#ifdef SPLITSERV"
    print "  html_map(fp, map_head, 0);"
    print "#endif"
    print " "
  } else if ($1 == "!BOT_LIST!") {
    print " "
    print "#ifdef STATSERV"
    print "  fprintf(fp, \"%s!%s@%s<BR>\\n\", StatServ.nick, StatServ.user, StatServ.host);"
    print "#endif"
    print "#ifdef SPLITSERV"
    print "  fprintf(fp, \"%s!%s@%s<BR>\\n\", SplitServ.nick, SplitServ.user, SplitServ.host);"
    print "#endif"
    print "  if (showadmin)"
    print "    fprintf(fp, \"%s!%s@%s<BR>\\n\", AdminServ.nick, AdminServ.user, AdminServ.host);"
    print " "
  } else if ($1 == "@SHOW_ADMIN@") {
    print " "
    print "  showadmin = 1;"
    print " "
  } else if ($1 == "@HIDE_UPLINK@") {
    print " "
    print "  hideuplink = 1;"
    print " "
  } else if ($1 == "@HIDE_VERSION@") {
    print " "
    print "#ifdef TRACK_VERSION"
    print "  hideversion = 1;"
    print "#endif"
    print " "
  } else if ($1 == "!TLD_TABLE!") {
    print " "
    print "  for (i = 0; i < T_TABLE_SIZE; i++)"
    print "  {"
    print "    for(t = tldlist[i]; t; t = t->next)"
    print "    {"
    print "      if (t->users > 0)"
    print "      {"
    print "        fprintf(fp, \"%d user%s on %s (%s) (%2.0f%%)<BR>\\n\", t->users,"
    print "        (t->users == 1) ? \"\" : \"s\", t->country, t->tld,"
    print "        (float)t->users / (float)netinfo.users * 100);"
    print "      }"
    print "    }"
    print "  }"
    print " "
  } else if ($1 == "!OPER_LIST!") {
    print " "
    print "  fprintf(fp, \"<OL>\\n\");"
    print "  for (i=0; i < U_TABLE_SIZE; i++)"
    print "  {"
    print "    for (u = userlist[i]; u; u = u->next)"
    print "    {"
    print "      if (IsUIsOper())"
    print "      {"
    print "#ifdef OPER_MODES"
    print "        fprintf(fp, \"<LI>[%c] %s on %s<BR>\\n\", opermode(u), u->nick, u->server->name);"
    print "#else"
    print "        fprintf(fp, \"<LI>%s on %s<BR>\\n\", u->nick, u->server->name);"
    print "#endif"
    print "      }"
    print "    }"
    print "  }"
    print "  fprintf(fp, \"</OL>\\n\");"
    print " "
  } else if ($1 == "!SPLIT_LIST!") {
    print " "
    print "#ifdef SPLITSERV"
    print "  {"
    print "    int i;"
    print "    int count = 0;"
    print "    char * td;"
    print "    time_t now = time(NULL);"
    print " "
    print "    for (i=0; i<MAXSERVER; i++)"
    print "    {"
    print "      if (split_table[i])"
    print "      {"
    print "        td = timediff(now - split_table[i]->ts);"
    print "        count++;"
    print "        fprintf(fp, \"%s for %s<BR>\\n\", split_table[i]->name, td);"
    print "      }"
    print "    }"
    print "    if (!count)"
    print "    {"
    print "      fprintf(fp, \"No Splits\\n\");"
    print "    }"
    print "  }"
    print "#endif"
    print " "
  } else if ($1 == "!VERSION_MAP!") {
    print " "
    print "#ifdef TRACK_VERSION"
    print "  fprintf(fp, \"<TABLE><TR><TH>Server</TH><TH>Version</TH></TR>\\r\");"
    print "  for (i=0; i < S_TABLE_SIZE; i++)"
    print "  {"
    print "    for (s = serverlist[i]; s; s = s->next)"
    print "    {"
    print "      if (IsHide())"
    print "      {"
    print "        if (strcasecmp(s->name, settings.services_name))"
    print "        {"
    print "          fprintf(fp, \"<TR><TD>%s</TD><TD>%s</TD></TR>\\r\", s->name, (s->version && s->version[0]) ?  s->version : \"Unknown Version\");"
    print "        }"
    print "      }"
    print "      else"
    print "      {"
    print "        fprintf(fp, \"<TR><TD>%s</TD><TD>%s</TD></TR>\\r\", s->name, (s->version && s->version[0]) ?  s->version : \"Unknown Version\");"
    print "      }"
    print "    }"
    print "  }"
    print "  fprintf(fp, \"</TABLE>\\r\");"
    print "#endif"
    print " "
  } else if ($1 == "!SERVER_DATA!") {
    print " "
    print "  for (i=0; i < S_TABLE_SIZE; i++)"
    print "    for (s = serverlist[i]; s; s = s->next)"
    print "    {"
    print "      fprintf(fp, \"<HR>\\n\");"
    print "      fprintf(fp, \"<A NAME=\\\"%s\\\"></A>\", s->name);"
    print "      fprintf(fp, \"<CENTER><H3>%s</H3></CENTER><P>\\n\", s->name);"
    print "      fprintf(fp, \"<B>Description Line:</B> %s<BR>\\n\", s->desc);"
    print "#ifdef TRACK_VERSION"
    print "      if (!hideversion && s->version && s->version[0])"
    print "        fprintf(fp, \"<B>Version:</B> %s<BR>\\n\", s->version);"
    print "#endif"
    print "      fprintf(fp, \"<B>Current User Count:</B> %d<BR>\\n\", s->users);"
    print "      fprintf(fp, \"<B>Max Users:</B> %ld at %s<BR>\\n\", s->stats->maxusers, sftime(s->stats->t_maxusers));"
    print "      fprintf(fp, \"<B>Current Oper Count:</B> %d<BR>\\n\", s->opers);"
    print "      fprintf(fp, \"<B>Max Opers:</B> %d at %s<BR>\\n\", s->stats->maxopers, sftime(s->stats->t_maxopers));"
    print "      fprintf(fp, \"<B>Connected Since:</B> %s<BR>\\n\", sftime(s->connected_since));"
    print "      if (!hideuplink)"
    print "      {"
    print "        if (s->uplink)"
    print "        {"
    print "          fprintf(fp, \"<B>Uplink:</B> <A HREF=\\\"#%s\\\">%s</A><BR>\\n\", s->uplink->name, s->uplink->name);"
    print "        }"
    print "      }"
    print "  }"
    print " "
  } else if ($1 == "!DYN_HEADER!") {
    print " "
    print "  fprintf(fp, \"<TITLE>IRC Statistics for %s </TITLE>\\n\", sftime(now));"
    print "  fprintf(fp, \"<META HTTP-EQUIV=\\\"Refresh\\\" CONTENT=\\\"%d\\\">\\n\", settings.html_time);"
    print " "
  } else if ($1 == "!SERVICE_LIST!") {
    print " "
    print "#ifdef IRCD_2_10"
    print "  {"
    print "    Service *sv = servicehead;"
    print "    while (sv)"
    print "    {"
    print "      fprintf(fp, \"%s@%s distribution %s (%s)<BR>\\n\", sv->nick, sv->server, sv->dist, sv->gecos);"
    print "      sv = sv->next;"
    print "    }"
    print "  }"
    print "#endif"
    print " "
  } else {
    print "     fprintf(fp, \""$0"\\n\");"
  }
}

END {
  print "  fclose(fp);"
  print "}"
}
